#include "InputLexer.h"

#include <sstream>
#include <iostream>

namespace { //The automaton data
    typedef std::size_t State;

    State REJECT = 79;

    unsigned char TRANS_IDX[256] = { (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)1, (unsigned char)1, (unsigned char)0, (unsigned char)0, (unsigned char)1, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)1, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)2, (unsigned char)3, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)4, (unsigned char)5, (unsigned char)0, (unsigned char)6, (unsigned char)7, (unsigned char)7, (unsigned char)7, (unsigned char)7, (unsigned char)7, (unsigned char)7, (unsigned char)7, (unsigned char)7, (unsigned char)7, (unsigned char)8, (unsigned char)9, (unsigned char)0, (unsigned char)0, (unsigned char)10, (unsigned char)0, (unsigned char)0, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)11, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)12, (unsigned char)0, (unsigned char)13, (unsigned char)14, (unsigned char)15, (unsigned char)16, (unsigned char)17, (unsigned char)18, (unsigned char)19, (unsigned char)20, (unsigned char)21, (unsigned char)14, (unsigned char)14, (unsigned char)22, (unsigned char)23, (unsigned char)24, (unsigned char)25, (unsigned char)26, (unsigned char)14, (unsigned char)27, (unsigned char)28, (unsigned char)29, (unsigned char)14, (unsigned char)14, (unsigned char)14, (unsigned char)30, (unsigned char)14, (unsigned char)14, (unsigned char)0, (unsigned char)31, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)32, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)33, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)34, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0,  };

    State TABLE[80 - 1][35] = { 
        {  79,  78,  79,  79,  71,  79,  79,  66,  76,  75,  79,  46,  47,  48,  48,  48,  48,  48,  48,  37,  48,  48,  16,  48,  45,  48,  1,  44,  32,  23,  48,  77,  79,  79,  73,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  2,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  7,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  3,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  4,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  5,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  6,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  8,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  9,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  10,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  11,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  12,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  13,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  14,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  15,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  17,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  49,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  18,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  19,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  20,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  21,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  22,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  24,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  25,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  26,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  27,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  28,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  29,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  30,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  31,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  33,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  34,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  35,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  36,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  38,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  39,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  40,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  41,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  42,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  43,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  51,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  55,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  46,  46,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  46,  47,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  50,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  52,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  53,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  54,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  56,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  57,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  58,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  59,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  60,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  61,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  79,  79,  79,  79,  },
        
        {  79,  79,  63,  79,  79,  67,  79,  79,  79,  79,  79,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  64,  64,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  65,  79,  79,  64,  64,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  66,  66,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  68,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  69,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  70,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  72,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  74,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  72,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
        
        {  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  },
         };

    InputLexer::TokenType TOKENS[80] = {  InputLexer::nonmatching,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::PARSER,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::PRECEDENCE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::LEXESIS,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::TERMINALS,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::START,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::GRAMMAR,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::TERMINAL,  InputLexer::TERMINAL,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::LEFT,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::RIGHT,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::VARIABLE,  InputLexer::NONASSOC,  InputLexer::nonmatching,  InputLexer::nonmatching,  InputLexer::nonmatching,  InputLexer::PARSERTYPE,  InputLexer::NUM,  InputLexer::nonmatching,  InputLexer::nonmatching,  InputLexer::nonmatching,  InputLexer::LEXESISNAME,  InputLexer::nonmatching,  InputLexer::ARROW,  InputLexer::nonmatching,  InputLexer::nonmatching,  InputLexer::SEMICOLON,  InputLexer::COLON,  InputLexer::PIPE,  InputLexer::ignore,  InputLexer::nonmatching,  };
}

InputLexer::InputLexer(std::istream& in) : m_offset(0), m_input(in) {

}

InputLexer::~InputLexer() {
}

InputLexer::Token InputLexer::nextToken() {
    TokenType type = ignore;
    std::string token;

    while (type == ignore) {
        State state = 0;
        std::size_t match_length = 0;
        token = "";

        while (!m_input.eof() && state != REJECT) {
            char c = m_input.peek();
            if (m_input.eof())
                break;

            token += c;

            state = TABLE[state][TRANS_IDX[(unsigned char)c]];
            if (TOKENS[state])
            {
                match_length = token.length();
                type = TOKENS[state];
            }
            m_input.get();
            ++m_offset;
        }

        std::size_t sdiff = token.length() - match_length;
        for (std::size_t i = 0; i < sdiff; i++)
        {
            m_input.putback(token[token.length() - i - 1]);
        }
        m_offset -= sdiff;

        if (!type || !match_length) {
            if (m_input.eof())
                throw NoMoreTokens();
            throw NoMatch();
        }

        token = token.substr(0, match_length);
    }

    Token t;
    t.type = type;
    t.content = token;
    return t;
}

void InputLexer::skip(std::size_t n) {
    for (size_t i = 0; i < n; i++) {
        m_input.get();
        ++m_offset;
    }
}

char InputLexer::peek() {
    if (m_input.eof())
        throw NoMoreTokens();
    return m_input.peek();
}

std::size_t InputLexer::getByteOffset() {
    return m_offset;
}
